%global debug_package %{nil}

%global commit 98ca6f2a54d20f171628055938619972514f7a07
%global commitdate 20240927
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:           ipu6-camera-bins
Summary:        Binary library for Intel IPU6
Version:        0.0
Release:        16.%{commitdate}git%{shortcommit}%{?dist}
License:        Redistributable, no modification permitted

Source0:        https://github.com/intel/%{name}/archive/%{commit}/%{name}-%{shortcommit}.tar.gz

BuildRequires:  systemd-rpm-macros
BuildRequires:  chrpath
BuildRequires:  patchelf

ExclusiveArch:  x86_64

# Require the new linux-firmware package
Requires:       linux-firmware >= 20240603-144
Requires:       (%{name}-kmod%{?_isa} = %{version}-%{release} or kernel-ipu6)
Requires:       v4l2-relayd
# Obsolete but do not provide old firmware packages
Obsoletes:      ipu6-camera-bins-firmware < 0.0-11
Obsoletes:      ivsc-firmware < 0.0-8

%if 0%{?el9}
Provides:       %{name}%{?_isa} = %{version}-%{release}
Provides:       libbroxton_ia_pal-ipu6.so.0()(64bit)
Provides:       libbroxton_ia_pal-ipu6ep.so.0()(64bit)
Provides:       libbroxton_ia_pal-ipu6epmtl.so.0()(64bit)
Provides:       libgcss-ipu6.so.0()(64bit)
Provides:       libgcss-ipu6ep.so.0()(64bit)
Provides:       libgcss-ipu6epmtl.so.0()(64bit)
Provides:       libia_aiq-ipu6.so.0()(64bit)
Provides:       libia_aiq-ipu6ep.so.0()(64bit)
Provides:       libia_aiq-ipu6epmtl.so.0()(64bit)
Provides:       libia_aiq_file_debug-ipu6.so.0()(64bit)
Provides:       libia_aiq_file_debug-ipu6ep.so.0()(64bit)
Provides:       libia_aiq_file_debug-ipu6epmtl.so.0()(64bit)
Provides:       libia_aiqb_parser-ipu6.so.0()(64bit)
Provides:       libia_aiqb_parser-ipu6ep.so.0()(64bit)
Provides:       libia_aiqb_parser-ipu6epmtl.so.0()(64bit)
Provides:       libia_bcomp-ipu6.so.0()(64bit)
Provides:       libia_bcomp-ipu6ep.so.0()(64bit)
Provides:       libia_bcomp-ipu6epmtl.so.0()(64bit)
Provides:       libia_cca-ipu6.so.0()(64bit)
Provides:       libia_cca-ipu6ep.so.0()(64bit)
Provides:       libia_cca-ipu6epmtl.so.0()(64bit)
Provides:       libia_ccat-ipu6.so.0()(64bit)
Provides:       libia_ccat-ipu6ep.so.0()(64bit)
Provides:       libia_ccat-ipu6epmtl.so.0()(64bit)
Provides:       libia_cmc_parser-ipu6.so.0()(64bit)
Provides:       libia_cmc_parser-ipu6ep.so.0()(64bit)
Provides:       libia_cmc_parser-ipu6epmtl.so.0()(64bit)
Provides:       libia_coordinate-ipu6.so.0()(64bit)
Provides:       libia_coordinate-ipu6ep.so.0()(64bit)
Provides:       libia_coordinate-ipu6epmtl.so.0()(64bit)
Provides:       libia_dvs-ipu6.so.0()(64bit)
Provides:       libia_dvs-ipu6ep.so.0()(64bit)
Provides:       libia_dvs-ipu6epmtl.so.0()(64bit)
Provides:       libia_emd_decoder-ipu6.so.0()(64bit)
Provides:       libia_emd_decoder-ipu6ep.so.0()(64bit)
Provides:       libia_emd_decoder-ipu6epmtl.so.0()(64bit)
Provides:       libia_exc-ipu6.so.0()(64bit)
Provides:       libia_exc-ipu6ep.so.0()(64bit)
Provides:       libia_exc-ipu6epmtl.so.0()(64bit)
Provides:       libia_isp_bxt-ipu6.so.0()(64bit)
Provides:       libia_isp_bxt-ipu6ep.so.0()(64bit)
Provides:       libia_isp_bxt-ipu6epmtl.so.0()(64bit)
Provides:       libia_lard-ipu6.so.0()(64bit)
Provides:       libia_lard-ipu6ep.so.0()(64bit)
Provides:       libia_lard-ipu6epmtl.so.0()(64bit)
Provides:       libia_log-ipu6.so.0()(64bit)
Provides:       libia_log-ipu6ep.so.0()(64bit)
Provides:       libia_log-ipu6epmtl.so.0()(64bit)
Provides:       libia_ltm-ipu6.so.0()(64bit)
Provides:       libia_ltm-ipu6ep.so.0()(64bit)
Provides:       libia_ltm-ipu6epmtl.so.0()(64bit)
Provides:       libia_mkn-ipu6.so.0()(64bit)
Provides:       libia_mkn-ipu6ep.so.0()(64bit)
Provides:       libia_mkn-ipu6epmtl.so.0()(64bit)
Provides:       libia_nvm-ipu6.so.0()(64bit)
Provides:       libia_nvm-ipu6ep.so.0()(64bit)
Provides:       libia_nvm-ipu6epmtl.so.0()(64bit)
%endif

%description
This provides the necessary binaries for Intel IPU6, including library and
firmware. The library includes necessary image processing algorithms and
3A algorithm for the camera.

%package devel
Summary:        IPU6 header files for development.
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
This provides the necessary header files for IPU6 development.


%package kmod
Summary:        IPU6 kmod modules wrapper.
Requires:       gstreamer1-plugins-icamerasrc
Requires:       intel-ipu6-kmod >= 0.0-16
Requires:       intel-usbio-kmod >= 0.0-2
Provides:       intel-ipu6-kmod-common = %{version}
Provides:       intel-usbio-kmod-common = %{version}

%description kmod
This provides the necessary kmod modules wrapper.

%prep
%setup -q -n %{name}-%{commit}
chrpath --delete lib/*.so

%build
# Nothing to build

%install
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_libdir}
cp -pr include/* %{buildroot}%{_includedir}
cp -pr lib/{pkgconfig,lib*} %{buildroot}%{_libdir}
patchelf --set-rpath %{_libdir} %{buildroot}%{_libdir}/*.so
sed -i \
    -e "s|libdir=\${prefix}/lib|libdir=%{_libdir}|g" \
    %{buildroot}%{_libdir}/pkgconfig/*.pc


%files
%license LICENSE
%doc *.md
%{_libdir}/*.so*

%files devel
%{_includedir}/*
%{_libdir}/pkgconfig/*
%{_libdir}/*.a

%files kmod


%changelog
* Sat Oct 05 2024 Jean-Marc Liger <ligenix@iscp.fr> - 0.0-16.20240927git98ca6f2
- Update to commit 98ca6f2a54d20f171628055938619972514f7a07
- These release ends former ipu_tgl ipu_adl ipu_mtl subdirectories

* Sat Sep 21 2024 Jean-Marc Liger <ligenix@iscp.fr> - 0.0-15.20240826git046d1d9
- Update to commit 046d1d94ea96a9ac09ba7b3c5421adedd1d1c333 (v1.0.1-nex-v6.6)
- Add kmod subpackage as IPU6 drivers could be in kernel >= 6.10

* Sun Jul 21 2024 Jean-Marc Liger <ligenix@iscp.fr> - 0.0-14.20240718git532cb2b
- Update to commit 532cb2b946b9fcb3038389a7cf126fe56f4203af

* Sun Jun 30 2024 Jean-Marc Liger <ligenix@iscp.fr> - 0.0-13.20240507git987b09a
- Update to commit 987b09ad7e6124ab8623a986f92ecb47061b8fa0

* Mon Jun 03 2024 Jean-Marc Liger <ligenix@iscp.fr> - 0.0-12.20240409git814c869
- IPU6 drivers require USBIO drivers new kmod module
- Add pkgconfig and static libs for libipu6se

* Sat May 25 2024 Jean-Marc Liger <ligenix@iscp.fr> - 0.0-11.20240409git814c869
- Update to the latest upstream commit
- IVSC and IPU6 firmware are now provided in linux-firmware >= 20240219-143
- Update License form Proprietary to Redistributable, no modification permitted

* Sat Apr 20 2024 Jean-Marc Liger <ligenix@iscp.fr> - 0.0-10.220231027gitaf5ba0c.1
- Fix x86-64 for EL9

* Fri Mar 08 2024 Kate Hsuan <hpa@redhat.com> - 0.0-10.20231027gitaf5ba0c
- Update to the latest upstream commit

* Sun Feb 04 2024 RPM Fusion Release Engineering <sergiomb@rpmfusion.org> - 0.0-9.20230208git276859f
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Tue Aug 08 2023 Kate Hsuan <hpa@redhat.com> - 0.0-8.20230208git276859f
- Updated to commit 276859fc6de83918a32727d676985ec40f31af2b

* Thu Aug 03 2023 RPM Fusion Release Engineering <sergiomb@rpmfusion.org> - 0.0-7.20221112git4694ba7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Tue May 09 2023 Kate Hsuan <hpa@redhat.com> - 0.0-6.20221112git4694ba7
- Updated dependency settings

* Tue Dec 13 2022 Kate Hsuan <hpa@redhat.com> - 0.0-5.20221112git4694ba7
- Fix indentation.
- Remove unnecessary dir macro.

* Thu Dec 8 2022 Kate Hsuan <hpa@redhat.com> - 0.0-4.20221112git4694ba7
- Add Requires to make sure version lock between main and -devel package.
  Move .a files to -devel package.
  Fix dir settings.
  Remove unnecessary for loop and duplicated commands.

* Mon Dec 5 2022 Kate Hsuan <hpa@redhat.com> - 0.0-3.20221112git4694ba7
- Set correct rpath for every .so files and put the ExclusiveArch to the
  suitable place.

* Tue Nov 22 2022 Kate Hsuan <hpa@redhat.com> - 0.0-2.20221112git4694ba7
- Small tweaks as a result of pkg-review (rf#6474), including
  setup macro parameters, path settings, and dependency settings.

* Thu Nov 17 2022 Kate Hsuan <hpa@redhat.com> - 0.0-1.20221112git4694ba7
- Revision is based on the pkg-review (rf#6474#c2).

* Tue Oct 25 2022 Kate Hsuan <hpa@redhat.com> - 0.0.1
- First commit
